diff --git a/meta-isar/recipes-bsp/u-boot/u-boot-de0-nano-soc_2021.10.bb b/meta-isar/recipes-bsp/u-boot/u-boot-de0-nano-soc_2021.10.bb
index dcb76c5..1340362 100644
--- a/meta-isar/recipes-bsp/u-boot/u-boot-de0-nano-soc_2021.10.bb
+++ b/meta-isar/recipes-bsp/u-boot/u-boot-de0-nano-soc_2021.10.bb
@@ -6,4 +6,5 @@
 require u-boot-${PV}.inc
 
 # Just for testing purposes, distro package would be recent enough
-U_BOOT_TOOLS_PACKAGE = "1"
+U_BOOT_BUILD_PROFILES += "tools"
+U_BOOT_BUILD_PROFILES += "dev"
diff --git a/meta-isar/recipes-bsp/u-boot/u-boot-stm32mp15x_2021.10.bb b/meta-isar/recipes-bsp/u-boot/u-boot-stm32mp15x_2021.10.bb
index 6d95643..ead6d38 100644
--- a/meta-isar/recipes-bsp/u-boot/u-boot-stm32mp15x_2021.10.bb
+++ b/meta-isar/recipes-bsp/u-boot/u-boot-stm32mp15x_2021.10.bb
@@ -4,3 +4,5 @@
 # SPDX-License-Identifier: MIT
 
 require u-boot-${PV}.inc
+
+U_BOOT_BUILD_PROFILES += "dev"
diff --git a/meta/recipes-bsp/u-boot/files/debian/control.tmpl b/meta/recipes-bsp/u-boot/files/debian/control.tmpl
index 9379be7..7ac11ad 100644
--- a/meta/recipes-bsp/u-boot/files/debian/control.tmpl
+++ b/meta/recipes-bsp/u-boot/files/debian/control.tmpl
@@ -11,4 +11,17 @@ Description: ${DESCRIPTION}, bootloader binaries
 
 Package: u-boot-${MACHINE}-dev
 Architecture: ${DISTRO_ARCH}
+Build-Profiles: <dev>
 Description: ${DESCRIPTION}, bootloader libraries
+
+Package: u-boot-tools
+Architecture: linux-any
+Build-Profiles: <tools>
+Depends: ${shlibs:Depends}, ${misc:Depends}
+Description: ${DESCRIPTION}, companion tools
+
+Package: u-boot-${MACHINE}-config
+Build-Profiles: <config>
+Provides: u-boot-config
+Architecture: ${DISTRO_ARCH}
+Description: ${DESCRIPTION}, environment configuration
diff --git a/meta/recipes-bsp/u-boot/files/debian/rules b/meta/recipes-bsp/u-boot/files/debian/rules
index 3d66762..121b00e 100755
--- a/meta/recipes-bsp/u-boot/files/debian/rules
+++ b/meta/recipes-bsp/u-boot/files/debian/rules
@@ -20,10 +20,17 @@ override_dh_auto_build:
 	else \
 		./scripts/get_default_envs.sh >u-boot-initial-env; \
 	fi
-	$(MAKE) $(PARALLEL_MAKE) $(SET_CROSS_BUILD_TOOLS) NO_SDL=1 tools-only envtools
+ifneq (,$(filter dev,$(DEB_BUILD_PROFILES)))
+	$(MAKE) $(PARALLEL_MAKE) $(SET_CROSS_BUILD_TOOLS) NO_SDL=1 envtools
+endif
+ifneq (,$(filter tools,$(DEB_BUILD_PROFILES)))
+	$(MAKE) $(PARALLEL_MAKE) $(SET_CROSS_BUILD_TOOLS) NO_SDL=1 tools-only
+endif
 
 override_dh_auto_install:
+ifneq (,$(filter dev,$(DEB_BUILD_PROFILES)))
 	mv tools/env/lib.a tools/env/libubootenv.a
+endif
 
 override_dh_auto_test:
 
diff --git a/meta/recipes-bsp/u-boot/u-boot-custom.inc b/meta/recipes-bsp/u-boot/u-boot-custom.inc
index 57d4f36..bc92552 100644
--- a/meta/recipes-bsp/u-boot/u-boot-custom.inc
+++ b/meta/recipes-bsp/u-boot/u-boot-custom.inc
@@ -31,8 +31,8 @@ DEBIAN_BUILD_DEPENDS += "${@', libssl-dev' if d.getVar('ISAR_CROSS_COMPILE') ==
 TEMPLATE_FILES = "debian/control.tmpl"
 TEMPLATE_VARS += "MACHINE DEBIAN_BUILD_DEPENDS"
 
-U_BOOT_TOOLS_PACKAGE ?= "0"
-U_BOOT_CONFIG_PACKAGE ?= "0"
+
+U_BOOT_BUILD_PROFILES ?= ""
 
 do_prepare_build() {
     cp -r ${WORKDIR}/debian ${S}/
@@ -42,31 +42,15 @@ do_prepare_build() {
     echo "${U_BOOT_BIN} /usr/lib/u-boot/${MACHINE}" > \
         ${S}/debian/u-boot-${MACHINE}.install
 
-    echo "tools/env/libubootenv.a usr/lib" > \
-        ${S}/debian/u-boot-${MACHINE}-dev.install
-
-    if [ "${U_BOOT_TOOLS_PACKAGE}" = "1" ]; then
-        cat <<EOF >>${S}/debian/control
-
-Package: u-boot-tools
-Architecture: linux-any
-Depends: \${shlibs:Depends}, \${misc:Depends}
-Description: ${DESCRIPTION}, companion tools
-EOF
+    if [ "${@bb.utils.contains('U_BOOT_BUILD_PROFILES', 'dev', 'yes', 'no', d)}" = "yes" ];then
+        echo "tools/env/libubootenv.a usr/lib" > \
+            ${S}/debian/u-boot-${MACHINE}-dev.install
     fi
 
-    if [ "${U_BOOT_CONFIG_PACKAGE}" = "1" ]; then
+    if [ "${@bb.utils.contains('U_BOOT_BUILD_PROFILES', 'config', 'yes', 'no', d)}" = "yes" ];then
         cp ${WORKDIR}/fw_env.config ${S}/ || \
             die "U_BOOT_CONFIG_PACKAGE requires a fw_env.config in SRC_URI"
 
-        cat <<EOF >>${S}/debian/control
-
-Package: u-boot-${MACHINE}-config
-Provides: u-boot-config
-Architecture: ${DISTRO_ARCH}
-Description: ${DESCRIPTION}, environment configuration
-EOF
-
         cat <<EOF >>${S}/debian/u-boot-${MACHINE}-config.install
 u-boot-initial-env /etc
 fw_env.config      /etc
@@ -77,4 +61,5 @@ EOF
 dpkg_runbuild_prepend() {
     export U_BOOT_CONFIG="${U_BOOT_CONFIG}"
     export U_BOOT_BIN="${U_BOOT_BIN}"
+    export DEB_BUILD_PROFILES="${U_BOOT_BUILD_PROFILES}"
 }