diff --git a/meta-isar/conf/local.conf.sample b/meta-isar/conf/local.conf.sample
index e26090642dfe..fa2edcf55165 100644
--- a/meta-isar/conf/local.conf.sample
+++ b/meta-isar/conf/local.conf.sample
@@ -41,27 +41,34 @@ BBMULTICONFIG = " \
     qemuarm-stretch \
     qemuarm-buster \
     qemuarm-bullseye \
+    qemuarm-bookworm \
     qemuarm64-stretch \
     qemuarm64-buster \
     qemuarm64-bullseye \
+    qemuarm64-bookworm \
     qemui386-stretch \
     qemui386-buster \
     qemui386-bullseye \
+    qemui386-bookworm \
     qemuamd64-stretch \
     qemuamd64-buster \
     qemuamd64-buster-tgz \
     qemuamd64-buster-cpiogz \
     qemuamd64-bullseye \
+    qemuamd64-bookworm \
     container-amd64-stretch \
     container-amd64-buster \
     container-amd64-bullseye \
+    container-amd64-bookworm \
     qemumipsel-stretch \
     qemumipsel-buster \
     qemumipsel-bullseye \
+    qemumipsel-bookworm \
     qemuriscv64-sid-ports \
     bananapi-buster \
     de0-nano-soc-buster \
     hikey-bullseye \
+    hikey-bookworm \
     nand-ubi-demo-buster \
     nanopi-neo-buster \
     stm32mp15x-buster \
diff --git a/meta-isar/conf/multiconfig/container-amd64-bookworm.conf b/meta-isar/conf/multiconfig/container-amd64-bookworm.conf
new file mode 100644
index 000000000000..f5e53996f80d
--- /dev/null
+++ b/meta-isar/conf/multiconfig/container-amd64-bookworm.conf
@@ -0,0 +1,7 @@
+#
+# Copyright (c) Siemens AG, 2021
+#
+# SPDX-License-Identifier: MIT
+
+MACHINE ?= "container-amd64"
+DISTRO ?= "debian-bookworm"
diff --git a/meta-isar/conf/multiconfig/hikey-bookworm.conf b/meta-isar/conf/multiconfig/hikey-bookworm.conf
new file mode 100644
index 000000000000..14095e54089a
--- /dev/null
+++ b/meta-isar/conf/multiconfig/hikey-bookworm.conf
@@ -0,0 +1,7 @@
+#
+# Copyright (c) Siemens AG, 2021
+#
+# SPDX-License-Identifier: MIT
+
+MACHINE = "hikey"
+DISTRO = "debian-bookworm"
diff --git a/meta-isar/conf/multiconfig/qemuamd64-bookworm.conf b/meta-isar/conf/multiconfig/qemuamd64-bookworm.conf
new file mode 100644
index 000000000000..a5ad814f443a
--- /dev/null
+++ b/meta-isar/conf/multiconfig/qemuamd64-bookworm.conf
@@ -0,0 +1,4 @@
+# This software is a part of ISAR.
+
+MACHINE ?= "qemuamd64"
+DISTRO ?= "debian-bookworm"
diff --git a/meta-isar/conf/multiconfig/qemuarm-bookworm.conf b/meta-isar/conf/multiconfig/qemuarm-bookworm.conf
new file mode 100644
index 000000000000..081923651188
--- /dev/null
+++ b/meta-isar/conf/multiconfig/qemuarm-bookworm.conf
@@ -0,0 +1,4 @@
+# This software is a part of ISAR.
+
+MACHINE ?= "qemuarm"
+DISTRO ?= "debian-bookworm"
diff --git a/meta-isar/conf/multiconfig/qemuarm64-bookworm.conf b/meta-isar/conf/multiconfig/qemuarm64-bookworm.conf
new file mode 100644
index 000000000000..4bbaa849678b
--- /dev/null
+++ b/meta-isar/conf/multiconfig/qemuarm64-bookworm.conf
@@ -0,0 +1,6 @@
+# This software is a part of ISAR.
+# Copyright (C) 2017 ilbers GmbH
+# Copyright (c) Siemens AG, 2019
+
+MACHINE ?= "qemuarm64"
+DISTRO ?= "debian-bookworm"
diff --git a/meta-isar/conf/multiconfig/qemui386-bookworm.conf b/meta-isar/conf/multiconfig/qemui386-bookworm.conf
new file mode 100644
index 000000000000..a71732be2a26
--- /dev/null
+++ b/meta-isar/conf/multiconfig/qemui386-bookworm.conf
@@ -0,0 +1,4 @@
+# This software is a part of ISAR.
+
+MACHINE ?= "qemui386"
+DISTRO ?= "debian-bookworm"
diff --git a/meta-isar/conf/multiconfig/qemumipsel-bookworm.conf b/meta-isar/conf/multiconfig/qemumipsel-bookworm.conf
new file mode 100644
index 000000000000..7016c1ec92a4
--- /dev/null
+++ b/meta-isar/conf/multiconfig/qemumipsel-bookworm.conf
@@ -0,0 +1,5 @@
+# This software is a part of ISAR.
+# Copyright (C) 2019 Mentor Graphics, a Siemens busines
+
+MACHINE ?= "qemumipsel"
+DISTRO ?= "debian-bookworm"
diff --git a/meta/conf/distro/debian-bookworm.conf b/meta/conf/distro/debian-bookworm.conf
new file mode 100644
index 000000000000..c83d6588374d
--- /dev/null
+++ b/meta/conf/distro/debian-bookworm.conf
@@ -0,0 +1,19 @@
+# This software is a part of ISAR.
+
+require debian-common.conf
+
+BASE_DISTRO_CODENAME = "bookworm"
+
+HOST_DISTRO ?= "debian-${BASE_DISTRO_CODENAME}"
+
+DISTRO_CONFIG_SCRIPT ?= "debian-configscript.sh"
+DISTRO_KERNELS ?= "4kc-malta 5kc-malta 686-pae 686 alpha-generic alpha-smp \
+	amd64 arm64 armmp-lpae armmp cloud-amd64 cloud-arm64 itanium \
+	loongson-3 m68k marvell mckinley mips32r6 mips32r6el mips64r6 \
+	mips64r6el octeon parisc parisc64 powerpc-smp powerpc powerpc64 \
+	powerpc64le riscv64 rpi rt-686-pae rt-amd64 rt-arm64 rt-armmp \
+	s390x sh7751r sh7785lcr sparc64-smp sparc64"
+
+IMAGE_PREINSTALL += "init"
+
+WIC_IMAGER_INSTALL += "python3-distutils"
diff --git a/meta/conf/distro/debian-bookworm.list b/meta/conf/distro/debian-bookworm.list
new file mode 100644
index 000000000000..f47e46efec07
--- /dev/null
+++ b/meta/conf/distro/debian-bookworm.list
@@ -0,0 +1,8 @@
+deb	http://deb.debian.org/debian bookworm main contrib non-free
+deb-src	http://deb.debian.org/debian bookworm main contrib non-free
+
+deb	http://deb.debian.org/debian-security/ bookworm-security main contrib non-free
+deb-src	http://deb.debian.org/debian-security/ bookworm-security main contrib non-free
+
+deb	http://deb.debian.org/debian bookworm-updates main contrib non-free
+deb-src	http://deb.debian.org/debian bookworm-updates main contrib non-free
diff --git a/testsuite/build_test/build_test.py b/testsuite/build_test/build_test.py
index 8f1ec18ed401..b49a4cfa8ddf 100644
--- a/testsuite/build_test/build_test.py
+++ b/testsuite/build_test/build_test.py
@@ -91,6 +91,16 @@ class CrossTest(CIBaseTest):
         except:
             self.cancel('KFAIL')
 
+    def test_cross_bookworm(self):
+        targets = [
+            'mc:qemuarm-bookworm:isar-image-base'
+                  ]
+
+        try:
+            self.perform_build_test(targets, 1, None)
+        except:
+            self.cancel('KFAIL')
+
 class SdkTest(CIBaseTest):
 
     """
@@ -150,6 +160,20 @@ class NoCrossTest(CIBaseTest):
         except:
             self.cancel('KFAIL')
 
+    def test_nocross_bookworm(self):
+        targets = [
+            'mc:qemuamd64-bookworm:isar-image-base',
+            'mc:qemuarm-bookworm:isar-image-base',
+            'mc:qemui386-bookworm:isar-image-base',
+            'mc:qemumipsel-bookworm:isar-image-base',
+            'mc:hikey-bookworm:isar-image-base'
+                  ]
+
+        try:
+            self.perform_build_test(targets, 0, None)
+        except:
+            self.cancel('KFAIL')
+
 class RebuildTest(CIBaseTest):
 
     """
@@ -186,7 +210,8 @@ class ContainerImageTest(CIBaseTest):
         targets = [
             'mc:container-amd64-stretch:isar-image-base',
             'mc:container-amd64-buster:isar-image-base',
-            'mc:container-amd64-bullseye:isar-image-base'
+            'mc:container-amd64-bullseye:isar-image-base',
+            'mc:container-amd64-bookworm:isar-image-base'
                   ]
 
         self.perform_container_test(targets, None)